54535cfef5ade71ddbf4700cd5447f040cc47d25
[arvados.git] / build / run-tests.sh
1 #!/bin/bash
2 # Copyright (C) The Arvados Authors. All rights reserved.
3 #
4 # SPDX-License-Identifier: AGPL-3.0
5
6 COLUMNS=80
7 . `dirname "$(readlink -f "$0")"`/run-library.sh
8
9 read -rd "\000" helpmessage <<EOF
10 $(basename $0): Install and test Arvados components.
11
12 Exit non-zero if any tests fail.
13
14 Syntax:
15         $(basename $0) WORKSPACE=/path/to/arvados [options]
16
17 Options:
18
19 --skip FOO     Do not test the FOO component.
20 --skip sanity  Skip initial dev environment sanity checks.
21 --skip install Do not run any install steps. Just run tests.
22                You should provide GOPATH, GEMHOME, and VENVDIR options
23                from a previous invocation if you use this option.
24 --only FOO     Do not test anything except the FOO component.
25 --temp DIR     Install components and dependencies under DIR instead of
26                making a new temporary directory. Implies --leave-temp.
27 --leave-temp   Do not remove GOPATH, virtualenv, and other temp dirs at exit.
28                Instead, show the path to give as --temp to reuse them in
29                subsequent invocations.
30 --repeat N     Repeat each install/test step until it succeeds N times.
31 --retry        Prompt to retry if an install or test suite fails.
32 --only-install Run specific install step
33 --short        Skip (or scale down) some slow tests.
34 --interactive  Set up, then prompt for test/install steps to perform.
35 WORKSPACE=path Arvados source tree to test.
36 CONFIGSRC=path Dir with config.yml file containing PostgreSQL section for use by tests.
37 services/api_test="TEST=test/functional/arvados/v1/collections_controller_test.rb"
38                Restrict apiserver tests to the given file
39 sdk/python_test="--test-suite tests.test_keep_locator"
40                Restrict Python SDK tests to the given class
41 apps/workbench_test="TEST=test/integration/pipeline_instances_test.rb"
42                Restrict Workbench tests to the given file
43 services/arv-git-httpd_test="-check.vv"
44                Show all log messages, even when tests pass (also works
45                with services/keepstore_test etc.)
46 ARVADOS_DEBUG=1
47                Print more debug messages
48 envvar=value   Set \$envvar to value. Primarily useful for WORKSPACE,
49                *_test, and other examples shown above.
50
51 Assuming "--skip install" is not given, all components are installed
52 into \$GOPATH, \$VENDIR, and \$GEMHOME before running any tests. Many
53 test suites depend on other components being installed, and installing
54 everything tends to be quicker than debugging dependencies.
55
56 As a special concession to the current CI server config, CONFIGSRC
57 defaults to $HOME/arvados-api-server if that directory exists.
58
59 More information and background:
60
61 https://arvados.org/projects/arvados/wiki/Running_tests
62
63 Available tests:
64
65 apps/workbench (*)
66 apps/workbench_units (*)
67 apps/workbench_functionals (*)
68 apps/workbench_integration (*)
69 apps/workbench_benchmark
70 apps/workbench_profile
71 cmd/arvados-client
72 cmd/arvados-server
73 doc
74 lib/cli
75 lib/cmd
76 lib/controller
77 lib/controller/federation
78 lib/controller/railsproxy
79 lib/controller/router
80 lib/controller/rpc
81 lib/crunchstat
82 lib/crunch-run
83 lib/cloud
84 lib/cloud/azure
85 lib/cloud/cloudtest
86 lib/dispatchcloud
87 lib/dispatchcloud/container
88 lib/dispatchcloud/scheduler
89 lib/dispatchcloud/sshexecutor
90 lib/dispatchcloud/worker
91 lib/mount
92 lib/pam
93 lib/service
94 services/api
95 services/arv-git-httpd
96 services/crunchstat
97 services/dockercleaner
98 services/fuse
99 services/fuse:py3
100 services/health
101 services/keep-web
102 services/keepproxy
103 services/keepstore
104 services/keep-balance
105 services/login-sync
106 services/crunch-dispatch-local
107 services/crunch-dispatch-slurm
108 services/ws
109 sdk/cli
110 sdk/python
111 sdk/python:py3
112 sdk/ruby
113 sdk/go/arvados
114 sdk/go/arvadosclient
115 sdk/go/auth
116 sdk/go/dispatch
117 sdk/go/keepclient
118 sdk/go/health
119 sdk/go/httpserver
120 sdk/go/manifest
121 sdk/go/blockdigest
122 sdk/go/asyncbuf
123 sdk/go/stats
124 sdk/go/crunchrunner
125 sdk/cwl:py3
126 sdk/R
127 sdk/java-v2
128 tools/sync-groups
129 tools/crunchstat-summary
130 tools/crunchstat-summary:py3
131 tools/keep-exercise
132 tools/keep-rsync
133 tools/keep-block-check
134
135 (*) apps/workbench is shorthand for apps/workbench_units +
136     apps/workbench_functionals + apps/workbench_integration
137
138 EOF
139
140 # First make sure to remove any ARVADOS_ variables from the calling
141 # environment that could interfere with the tests.
142 unset $(env | cut -d= -f1 | grep \^ARVADOS_)
143
144 # Reset other variables that could affect our [tests'] behavior by
145 # accident.
146 GITDIR=
147 GOPATH=
148 VENVDIR=
149 VENV3DIR=
150 PYTHONPATH=
151 GEMHOME=
152 PERLINSTALLBASE=
153 R_LIBS=
154 export LANG=en_US.UTF-8
155
156 short=
157 only_install=
158 temp=
159 temp_preserve=
160
161 clear_temp() {
162     if [[ -z "$temp" ]]; then
163         # we did not even get as far as making a temp dir
164         :
165     elif [[ -z "$temp_preserve" ]]; then
166         # Go creates readonly dirs in the module cache, which cause
167         # "rm -rf" to fail unless we chmod first.
168         chmod -R u+w "$temp"
169         rm -rf "$temp"
170     else
171         echo "Leaving behind temp dirs in $temp"
172     fi
173 }
174
175 fatal() {
176     clear_temp
177     echo >&2 "Fatal: $* (encountered in ${FUNCNAME[1]} at ${BASH_SOURCE[1]} line ${BASH_LINENO[0]})"
178     exit 1
179 }
180
181 exit_cleanly() {
182     trap - INT
183     if which create-plot-data-from-log.sh >/dev/null; then
184         create-plot-data-from-log.sh $BUILD_NUMBER "$WORKSPACE/apps/workbench/log/test.log" "$WORKSPACE/apps/workbench/log/"
185     fi
186     rotate_logfile "$WORKSPACE/apps/workbench/log/" "test.log"
187     stop_services
188     rotate_logfile "$WORKSPACE/services/api/log/" "test.log"
189     report_outcomes
190     clear_temp
191     exit ${#failures}
192 }
193
194 sanity_checks() {
195     [[ -n "${skip[sanity]}" ]] && return 0
196     ( [[ -n "$WORKSPACE" ]] && [[ -d "$WORKSPACE/services" ]] ) \
197         || fatal "WORKSPACE environment variable not set to a source directory (see: $0 --help)"
198     [[ -z "$CONFIGSRC" ]] || [[ -s "$CONFIGSRC/config.yml" ]] \
199         || fatal "CONFIGSRC is $CONFIGSRC but '$CONFIGSRC/config.yml' is empty or not found (see: $0 --help)"
200     echo Checking dependencies:
201     echo "locale: ${LANG}"
202     [[ "$(locale charmap)" = "UTF-8" ]] \
203         || fatal "Locale '${LANG}' is broken/missing. Try: echo ${LANG} | sudo tee -a /etc/locale.gen && sudo locale-gen"
204     echo -n 'ruby: '
205     ruby -v \
206         || fatal "No ruby. Install >=2.1.9 (using rbenv, rvm, or source)"
207     echo -n 'go: '
208     go version \
209         || fatal "No go binary. See http://golang.org/doc/install"
210     [[ $(go version) =~ go1.([0-9]+) ]] && [[ ${BASH_REMATCH[1]} -ge 12 ]] \
211         || fatal "Go >= 1.12 required. See http://golang.org/doc/install"
212     echo -n 'gcc: '
213     gcc --version | egrep ^gcc \
214         || fatal "No gcc. Try: apt-get install build-essential"
215     echo -n 'fuse.h: '
216     find /usr/include -path '*fuse/fuse.h' | egrep --max-count=1 . \
217         || fatal "No fuse/fuse.h. Try: apt-get install libfuse-dev"
218     echo -n 'gnutls.h: '
219     find /usr/include -path '*gnutls/gnutls.h' | egrep --max-count=1 . \
220         || fatal "No gnutls/gnutls.h. Try: apt-get install libgnutls28-dev"
221     echo -n 'virtualenv: '
222     python3 -m venv -h | egrep --max-count=1 . \
223         || fatal "No virtualenv. Try: apt-get install python3-venv"
224     echo -n 'Python3 pyconfig.h: '
225     find /usr/include -path '*/python3*/pyconfig.h' | egrep --max-count=1 . \
226         || fatal "No Python3 pyconfig.h. Try: apt-get install python3-dev"
227     which netstat \
228         || fatal "No netstat. Try: apt-get install net-tools"
229     echo -n 'nginx: '
230     PATH="$PATH:/sbin:/usr/sbin:/usr/local/sbin" nginx -v \
231         || fatal "No nginx. Try: apt-get install nginx"
232     echo -n 'perl: '
233     perl -v | grep version \
234         || fatal "No perl. Try: apt-get install perl"
235     for mod in ExtUtils::MakeMaker JSON LWP Net::SSL; do
236         echo -n "perl $mod: "
237         perl -e "use $mod; print \"\$$mod::VERSION\\n\"" \
238             || fatal "No $mod. Try: apt-get install perl-modules libcrypt-ssleay-perl libjson-perl libwww-perl"
239     done
240     echo -n 'gitolite: '
241     which gitolite \
242         || fatal "No gitolite. Try: apt-get install gitolite3"
243     echo -n 'npm: '
244     npm --version \
245         || fatal "No npm. Try: wget -O- https://nodejs.org/dist/v10.23.1/node-v10.23.1-linux-x64.tar.xz | sudo tar -C /usr/local -xJf - && sudo ln -s ../node-v10.23.1-linux-x64/bin/{node,npm} /usr/local/bin/"
246     echo -n 'cadaver: '
247     cadaver --version | grep -w cadaver \
248           || fatal "No cadaver. Try: apt-get install cadaver"
249     echo -n 'libattr1 xattr.h: '
250     find /usr/include -path '*/attr/xattr.h' | egrep --max-count=1 . \
251         || fatal "No libattr1 xattr.h. Try: apt-get install libattr1-dev"
252     echo -n 'libcurl curl.h: '
253     find /usr/include -path '*/curl/curl.h' | egrep --max-count=1 . \
254         || fatal "No libcurl curl.h. Try: apt-get install libcurl4-gnutls-dev"
255     echo -n 'libpq libpq-fe.h: '
256     find /usr/include -path '*/postgresql/libpq-fe.h' | egrep --max-count=1 . \
257         || fatal "No libpq libpq-fe.h. Try: apt-get install libpq-dev"
258     echo -n 'libpam pam_appl.h: '
259     find /usr/include -path '*/security/pam_appl.h' | egrep --max-count=1 . \
260         || fatal "No libpam pam_appl.h. Try: apt-get install libpam0g-dev"
261     echo -n 'postgresql: '
262     psql --version || fatal "No postgresql. Try: apt-get install postgresql postgresql-client-common"
263     echo -n 'phantomjs: '
264     phantomjs --version || fatal "No phantomjs. Try: apt-get install phantomjs"
265     echo -n 'xvfb: '
266     which Xvfb || fatal "No xvfb. Try: apt-get install xvfb"
267     echo -n 'graphviz: '
268     dot -V || fatal "No graphviz. Try: apt-get install graphviz"
269     echo -n 'geckodriver: '
270     geckodriver --version | grep ^geckodriver || echo "No geckodriver. Try: wget -O- https://github.com/mozilla/geckodriver/releases/download/v0.23.0/geckodriver-v0.23.0-linux64.tar.gz | sudo tar -C /usr/local/bin -xzf - geckodriver"
271
272     if [[ "$NEED_SDK_R" = true ]]; then
273       # R SDK stuff
274       echo -n 'R: '
275       which Rscript || fatal "No Rscript. Try: apt-get install r-base"
276       echo -n 'testthat: '
277       Rscript -e "library('testthat')" || fatal "No testthat. Try: apt-get install r-cran-testthat"
278       # needed for roxygen2, needed for devtools, needed for R sdk
279       pkg-config --exists libxml-2.0 || fatal "No libxml2. Try: apt-get install libxml2-dev"
280       # needed for pkgdown, builds R SDK doc pages
281       which pandoc || fatal "No pandoc. Try: apt-get install pandoc"
282     fi
283     echo 'procs with /dev/fuse open:'
284     find /proc/*/fd -lname /dev/fuse 2>/dev/null | cut -d/ -f3 | xargs --no-run-if-empty ps -lywww
285     echo 'grep fuse /proc/self/mountinfo:'
286     grep fuse /proc/self/mountinfo
287 }
288
289 rotate_logfile() {
290   # i.e.  rotate_logfile "$WORKSPACE/apps/workbench/log/" "test.log"
291   # $BUILD_NUMBER is set by Jenkins if this script is being called as part of a Jenkins run
292   if [[ -f "$1/$2" ]]; then
293     THEDATE=`date +%Y%m%d%H%M%S`
294     mv "$1/$2" "$1/$THEDATE-$BUILD_NUMBER-$2"
295     gzip "$1/$THEDATE-$BUILD_NUMBER-$2"
296   fi
297 }
298
299 declare -a failures
300 declare -A skip
301 declare -A only
302 declare -A testargs
303 skip[apps/workbench_profile]=1
304
305 while [[ -n "$1" ]]
306 do
307     arg="$1"; shift
308     case "$arg" in
309         --help)
310             echo >&2 "$helpmessage"
311             echo >&2
312             exit 1
313             ;;
314         --skip)
315             skip[$1]=1; shift
316             ;;
317         --only)
318             only[$1]=1; skip[$1]=""; shift
319             ;;
320         --short)
321             short=1
322             ;;
323         --interactive)
324             interactive=1
325             ;;
326         --skip-install)
327             skip[install]=1
328             ;;
329         --only-install)
330             only_install="$1"; shift
331             ;;
332         --temp)
333             temp="$1"; shift
334             temp_preserve=1
335             ;;
336         --leave-temp)
337             temp_preserve=1
338             ;;
339         --repeat)
340             repeat=$((${1}+0)); shift
341             ;;
342         --retry)
343             retry=1
344             ;;
345         *_test=*)
346             suite="${arg%%_test=*}"
347             args="${arg#*=}"
348             testargs["$suite"]="$args"
349             ;;
350         *=*)
351             eval export $(echo $arg | cut -d= -f1)=\"$(echo $arg | cut -d= -f2-)\"
352             ;;
353         *)
354             echo >&2 "$0: Unrecognized option: '$arg'. Try: $0 --help"
355             exit 1
356             ;;
357     esac
358 done
359
360 # R SDK installation is very slow (~360s in a clean environment) and only
361 # required when testing it. Skip that step if it is not needed.
362 NEED_SDK_R=true
363
364 if [[ ${#only[@]} -ne 0 ]] &&
365    [[ -z "${only['sdk/R']}" && -z "${only['doc']}" ]]; then
366   NEED_SDK_R=false
367 fi
368
369 if [[ ${skip["sdk/R"]} == 1 && ${skip["doc"]} == 1 ]]; then
370   NEED_SDK_R=false
371 fi
372
373 if [[ $NEED_SDK_R == false ]]; then
374         echo "R SDK not needed, it will not be installed."
375 fi
376
377 checkpidfile() {
378     svc="$1"
379     pid="$(cat "$WORKSPACE/tmp/${svc}.pid")"
380     if [[ -z "$pid" ]] || ! kill -0 "$pid"; then
381         tail $WORKSPACE/tmp/${1}*.log
382         echo "${svc} pid ${pid} not running"
383         return 1
384     fi
385     echo "${svc} pid ${pid} ok"
386 }
387
388 checkhealth() {
389     svc="$1"
390     base=$("${VENV3DIR}/bin/python3" -c "import yaml; print(list(yaml.safe_load(open('$ARVADOS_CONFIG','r'))['Clusters']['zzzzz']['Services']['$1']['InternalURLs'].keys())[0])")
391     url="$base/_health/ping"
392     if ! curl -Ss -H "Authorization: Bearer e687950a23c3a9bceec28c6223a06c79" "${url}" | tee -a /dev/stderr | grep '"OK"'; then
393         echo "${url} failed"
394         return 1
395     fi
396 }
397
398 checkdiscoverydoc() {
399     dd="https://${1}/discovery/v1/apis/arvados/v1/rest"
400     if ! (set -o pipefail; curl -fsk "$dd" | grep -q ^{ ); then
401         echo >&2 "ERROR: could not retrieve discovery doc from RailsAPI at $dd"
402         tail -v $WORKSPACE/tmp/railsapi.log
403         return 1
404     fi
405     echo "${dd} ok"
406 }
407
408 start_services() {
409     if [[ -n "$ARVADOS_TEST_API_HOST" ]]; then
410         return 0
411     fi
412     . "$VENV3DIR/bin/activate"
413     echo 'Starting API, controller, keepproxy, keep-web, arv-git-httpd, ws, and nginx ssl proxy...'
414     if [[ ! -d "$WORKSPACE/services/api/log" ]]; then
415         mkdir -p "$WORKSPACE/services/api/log"
416     fi
417     # Remove empty api.pid file if it exists
418     if [[ -f "$WORKSPACE/tmp/api.pid" && ! -s "$WORKSPACE/tmp/api.pid" ]]; then
419         rm -f "$WORKSPACE/tmp/api.pid"
420     fi
421     all_services_stopped=
422     fail=1
423
424     cd "$WORKSPACE" \
425         && eval $(python3 sdk/python/tests/run_test_server.py start --auth admin) \
426         && export ARVADOS_TEST_API_HOST="$ARVADOS_API_HOST" \
427         && export ARVADOS_TEST_API_INSTALLED="$$" \
428         && checkpidfile api \
429         && checkdiscoverydoc $ARVADOS_API_HOST \
430         && eval $(python3 sdk/python/tests/run_test_server.py start_nginx) \
431         && checkpidfile nginx \
432         && python3 sdk/python/tests/run_test_server.py start_controller \
433         && checkpidfile controller \
434         && checkhealth Controller \
435         && checkdiscoverydoc $ARVADOS_API_HOST \
436         && python3 sdk/python/tests/run_test_server.py start_keep_proxy \
437         && checkpidfile keepproxy \
438         && python3 sdk/python/tests/run_test_server.py start_keep-web \
439         && checkpidfile keep-web \
440         && checkhealth WebDAV \
441         && python3 sdk/python/tests/run_test_server.py start_arv-git-httpd \
442         && checkpidfile arv-git-httpd \
443         && checkhealth GitHTTP \
444         && python3 sdk/python/tests/run_test_server.py start_ws \
445         && checkpidfile ws \
446         && export ARVADOS_TEST_PROXY_SERVICES=1 \
447         && (env | egrep ^ARVADOS) \
448         && fail=0
449     deactivate
450     if [[ $fail != 0 ]]; then
451         unset ARVADOS_TEST_API_HOST
452     fi
453     return $fail
454 }
455
456 stop_services() {
457     if [[ -n "$all_services_stopped" ]]; then
458         return
459     fi
460     unset ARVADOS_TEST_API_HOST ARVADOS_TEST_PROXY_SERVICES
461     . "$VENV3DIR/bin/activate" || return
462     cd "$WORKSPACE" \
463         && python3 sdk/python/tests/run_test_server.py stop_nginx \
464         && python3 sdk/python/tests/run_test_server.py stop_arv-git-httpd \
465         && python3 sdk/python/tests/run_test_server.py stop_ws \
466         && python3 sdk/python/tests/run_test_server.py stop_keep-web \
467         && python3 sdk/python/tests/run_test_server.py stop_keep_proxy \
468         && python3 sdk/python/tests/run_test_server.py stop_controller \
469         && python3 sdk/python/tests/run_test_server.py stop \
470         && all_services_stopped=1
471     deactivate
472     unset ARVADOS_CONFIG
473 }
474
475 interrupt() {
476     failures+=("($(basename $0) interrupted)")
477     exit_cleanly
478 }
479 trap interrupt INT
480
481 setup_ruby_environment() {
482     if [[ -s "$HOME/.rvm/scripts/rvm" ]] ; then
483         source "$HOME/.rvm/scripts/rvm"
484         using_rvm=true
485     elif [[ -s "/usr/local/rvm/scripts/rvm" ]] ; then
486         source "/usr/local/rvm/scripts/rvm"
487         using_rvm=true
488     else
489         using_rvm=false
490     fi
491
492     if [[ "$using_rvm" == true ]]; then
493         # If rvm is in use, we can't just put separate "dependencies"
494         # and "gems-under-test" paths to GEM_PATH: passenger resets
495         # the environment to the "current gemset", which would lose
496         # our GEM_PATH and prevent our test suites from running ruby
497         # programs (for example, the Workbench test suite could not
498         # boot an API server or run arv). Instead, we have to make an
499         # rvm gemset and use it for everything.
500
501         [[ `type rvm | head -n1` == "rvm is a function" ]] \
502             || fatal 'rvm check'
503
504         # Put rvm's favorite path back in first place (overriding
505         # virtualenv, which just put itself there). Ignore rvm's
506         # complaint about not being in first place already.
507         rvm use @default 2>/dev/null
508
509         # Create (if needed) and switch to an @arvados-tests-* gemset,
510         # salting the gemset name so it doesn't interfere with
511         # concurrent builds in other workspaces. Leave the choice of
512         # ruby to the caller.
513         gemset="arvados-tests-$(echo -n "${WORKSPACE}" | md5sum | head -c16)"
514         rvm use "@${gemset}" --create \
515             || fatal 'rvm gemset setup'
516
517         rvm env
518         (bundle version | grep -q 2.2.19) || gem install --no-document bundler -v 2.2.19
519         bundle="$(which bundle)"
520         echo "$bundle"
521         "$bundle" version | grep 2.2.19 || fatal 'install bundler'
522     else
523         # When our "bundle install"s need to install new gems to
524         # satisfy dependencies, we want them to go where "gem install
525         # --user-install" would put them. (However, if the caller has
526         # already set GEM_HOME, we assume that's where dependencies
527         # should be installed, and we should leave it alone.)
528
529         if [ -z "$GEM_HOME" ]; then
530             user_gempath="$(gem env gempath)"
531             export GEM_HOME="${user_gempath%%:*}"
532         fi
533         PATH="$(gem env gemdir)/bin:$PATH"
534
535         # When we build and install our own gems, we install them in our
536         # $GEMHOME tmpdir, and we want them to be at the front of GEM_PATH and
537         # PATH so integration tests prefer them over other versions that
538         # happen to be installed in $user_gempath, system dirs, etc.
539
540         tmpdir_gem_home="$(env - PATH="$PATH" HOME="$GEMHOME" gem env gempath | cut -f1 -d:)"
541         PATH="$tmpdir_gem_home/bin:$PATH"
542         export GEM_PATH="$tmpdir_gem_home:$(gem env gempath)"
543
544         echo "Will install dependencies to $(gem env gemdir)"
545         echo "Will install bundler and arvados gems to $tmpdir_gem_home"
546         echo "Gem search path is GEM_PATH=$GEM_PATH"
547         bundle="bundle"
548         (
549             export HOME=$GEMHOME
550             versions=(2.2.19)
551             for v in ${versions[@]}; do
552                 if ! gem list --installed --version "${v}" bundler >/dev/null; then
553                     gem install --no-document --user $(for v in ${versions[@]}; do echo bundler:${v}; done)
554                     break
555                 fi
556             done
557             "$bundle" version | tee /dev/stderr | grep -q 'version 2'
558         ) || fatal 'install bundler'
559         if test -d /var/lib/arvados-arvbox/ ; then
560             # Inside arvbox, use bundler-installed binstubs.  The
561             # system bundler and rail's own bin/bundle refuse to work.
562             # I don't know why.
563             bundle=binstubs/bundle
564         fi
565     fi
566 }
567
568 with_test_gemset() {
569     if [[ "$using_rvm" == true ]]; then
570         "$@"
571     else
572         GEM_HOME="$tmpdir_gem_home" GEM_PATH="$tmpdir_gem_home" "$@"
573     fi
574 }
575
576 gem_uninstall_if_exists() {
577     if gem list "$1\$" | egrep '^\w'; then
578         gem uninstall --force --all --executables "$1"
579     fi
580 }
581
582 setup_virtualenv() {
583     local venvdest="$1"; shift
584     if ! [[ -e "$venvdest/bin/activate" ]] || ! [[ -e "$venvdest/bin/pip3" ]]; then
585         python3 -m venv "$@" "$venvdest" || fatal "virtualenv $venvdest failed"
586     elif [[ -n "$short" ]]; then
587         return
588     fi
589     "$venvdest/bin/pip3" install --no-cache-dir 'setuptools>=18.5' 'pip>=7'
590 }
591
592 initialize() {
593     # If dependencies like ruby, go, etc. are installed in
594     # /var/lib/arvados -- presumably by "arvados-server install" --
595     # then we want to use those versions, instead of whatever happens
596     # to be installed in /usr.
597     PATH="/var/lib/arvados/bin:${PATH}"
598     sanity_checks
599
600     echo "WORKSPACE=$WORKSPACE"
601
602     # Clean up .pyc files that may exist in the workspace
603     cd "$WORKSPACE"
604     find -name '*.pyc' -delete
605
606     if [[ -z "$temp" ]]; then
607         temp="$(mktemp -d)"
608     fi
609
610     # Set up temporary install dirs (unless existing dirs were supplied)
611     for tmpdir in VENV3DIR GOPATH GEMHOME PERLINSTALLBASE R_LIBS
612     do
613         if [[ -z "${!tmpdir}" ]]; then
614             eval "$tmpdir"="$temp/$tmpdir"
615         fi
616         if ! [[ -d "${!tmpdir}" ]]; then
617             mkdir "${!tmpdir}" || fatal "can't create ${!tmpdir} (does $temp exist?)"
618         fi
619     done
620
621     rm -vf "${WORKSPACE}/tmp/*.log"
622
623     export PERLINSTALLBASE
624     export PERL5LIB="$PERLINSTALLBASE/lib/perl5${PERL5LIB:+:$PERL5LIB}"
625
626     export R_LIBS
627
628     export GOPATH
629     # Make sure our compiled binaries under test override anything
630     # else that might be in the environment.
631     export PATH=$GOPATH/bin:$PATH
632
633     # Jenkins config requires that glob tmp/*.log match something. Ensure
634     # that happens even if we don't end up running services that set up
635     # logging.
636     mkdir -p "${WORKSPACE}/tmp/" || fatal "could not mkdir ${WORKSPACE}/tmp"
637     touch "${WORKSPACE}/tmp/controller.log" || fatal "could not touch ${WORKSPACE}/tmp/controller.log"
638
639     unset http_proxy https_proxy no_proxy
640
641     # Note: this must be the last time we change PATH, otherwise rvm will
642     # whine a lot.
643     setup_ruby_environment
644
645     echo "PATH is $PATH"
646 }
647
648 install_env() {
649     go mod download || fatal "Go deps failed"
650     which goimports >/dev/null || go install golang.org/x/tools/cmd/goimports@latest || fatal "Go setup failed"
651
652     setup_virtualenv "$VENV3DIR"
653     . "$VENV3DIR/bin/activate"
654
655     # Needed for run_test_server.py which is used by certain (non-Python) tests.
656     # pdoc3 needed to generate the Python SDK documentation.
657     (
658         set -e
659         "${VENV3DIR}/bin/pip3" install wheel
660         "${VENV3DIR}/bin/pip3" install PyYAML
661         "${VENV3DIR}/bin/pip3" install httplib2
662         "${VENV3DIR}/bin/pip3" install future
663         "${VENV3DIR}/bin/pip3" install google-api-python-client
664         "${VENV3DIR}/bin/pip3" install ciso8601
665         "${VENV3DIR}/bin/pip3" install pycurl
666         "${VENV3DIR}/bin/pip3" install ws4py
667         "${VENV3DIR}/bin/pip3" install pdoc3
668         cd "$WORKSPACE/sdk/python"
669         python3 setup.py install
670     ) || fatal "installing PyYAML and sdk/python failed"
671 }
672
673 retry() {
674     remain="${repeat}"
675     while :
676     do
677         if ${@}; then
678             if [[ "$remain" -gt 1 ]]; then
679                 remain=$((${remain}-1))
680                 title "(repeating ${remain} more times)"
681             else
682                 break
683             fi
684         elif [[ "$retry" == 1 ]]; then
685             read -p 'Try again? [Y/n] ' x
686             if [[ "$x" != "y" ]] && [[ "$x" != "" ]]
687             then
688                 break
689             fi
690         else
691             break
692         fi
693     done
694 }
695
696 do_test() {
697     case "${1}" in
698         apps/workbench_units | apps/workbench_functionals | apps/workbench_integration)
699             suite=apps/workbench
700             ;;
701         *)
702             suite="${1}"
703             ;;
704     esac
705     if [[ -n "${skip[$suite]}" || \
706               -n "${skip[$1]}" || \
707               (${#only[@]} -ne 0 && ${only[$suite]} -eq 0 && ${only[$1]} -eq 0) ]]; then
708         return 0
709     fi
710     case "${1}" in
711         services/api)
712             stop_services
713             check_arvados_config "$1"
714             ;;
715         gofmt | doc | lib/cli | lib/cloud/azure | lib/cloud/ec2 | lib/cloud/cloudtest | lib/cmd | lib/dispatchcloud/sshexecutor | lib/dispatchcloud/worker)
716             check_arvados_config "$1"
717             # don't care whether services are running
718             ;;
719         *)
720             check_arvados_config "$1"
721             if ! start_services; then
722                 checkexit 1 "$1 tests"
723                 title "test $1 -- failed to start services"
724                 return 1
725             fi
726             ;;
727     esac
728     retry do_test_once ${@}
729 }
730
731 go_ldflags() {
732     version=${ARVADOS_VERSION:-$(git log -n1 --format=%H)-dev}
733     echo "-X git.arvados.org/arvados.git/lib/cmd.version=${version} -X main.version=${version}"
734 }
735
736 do_test_once() {
737     unset result
738
739     title "test $1"
740     timer_reset
741
742     result=
743     if which deactivate >/dev/null; then deactivate; fi
744     if ! . "$VENV3DIR/bin/activate"
745     then
746         result=1
747     elif [[ "$2" == "go" ]]
748     then
749         covername="coverage-$(echo "$1" | sed -e 's/\//_/g')"
750         coverflags=("-covermode=count" "-coverprofile=$WORKSPACE/tmp/.$covername.tmp")
751         # We do "go install" here to catch compilation errors
752         # before trying "go test". Otherwise, coverage-reporting
753         # mode makes Go show the wrong line numbers when reporting
754         # compilation errors.
755         go install -ldflags "$(go_ldflags)" "$WORKSPACE/$1" && \
756             cd "$WORKSPACE/$1" && \
757             if [[ -n "${testargs[$1]}" ]]
758         then
759             # "go test -check.vv giturl" doesn't work, but this
760             # does:
761             go test ${short:+-short} ${testargs[$1]}
762         else
763             # The above form gets verbose even when testargs is
764             # empty, so use this form in such cases:
765             go test ${short:+-short} ${coverflags[@]} "git.arvados.org/arvados.git/$1"
766         fi
767         result=${result:-$?}
768         if [[ -f "$WORKSPACE/tmp/.$covername.tmp" ]]
769         then
770             go tool cover -html="$WORKSPACE/tmp/.$covername.tmp" -o "$WORKSPACE/tmp/$covername.html"
771             rm "$WORKSPACE/tmp/.$covername.tmp"
772         fi
773         [[ $result = 0 ]] && gofmt -e -d *.go
774     elif [[ "$2" == "pip" ]]
775     then
776         tries=0
777         cd "$WORKSPACE/$1" && while :
778         do
779             tries=$((${tries}+1))
780             # $3 can name a path directory for us to use, including trailing
781             # slash; e.g., the bin/ subdirectory of a virtualenv.
782             if [[ -e "${3}activate" ]]; then
783                 . "${3}activate"
784             fi
785             python setup.py ${short:+--short-tests-only} test ${testargs[$1]}
786             result=$?
787             if [[ ${tries} < 3 && ${result} == 137 ]]
788             then
789                 printf '\n*****\n%s tests killed -- retrying\n*****\n\n' "$1"
790                 continue
791             else
792                 break
793             fi
794         done
795     elif [[ "$2" != "" ]]
796     then
797         "test_$2"
798     else
799         "test_$1"
800     fi
801     result=${result:-$?}
802     checkexit $result "$1 tests"
803     title "test $1 -- `timer`"
804     return $result
805 }
806
807 check_arvados_config() {
808     if [[ "$1" = "env" ]] ; then
809         return
810     fi
811     if [[ -z "$ARVADOS_CONFIG" ]] ; then
812         # Create config file.  The run_test_server script requires PyYAML,
813         # so virtualenv needs to be active.  Downstream steps like
814         # workbench install which require a valid config.yml.
815         if [[ ! -s "$VENV3DIR/bin/activate" ]] ; then
816             install_env
817         fi
818         . "$VENV3DIR/bin/activate"
819         cd "$WORKSPACE"
820         eval $(python3 sdk/python/tests/run_test_server.py setup_config)
821         deactivate
822     fi
823 }
824
825 do_install() {
826     if [[ -n "${skip[install]}" || ( -n "${only_install}" && "${only_install}" != "${1}" && "${only_install}" != "${2}" ) ]]; then
827         return 0
828     fi
829     check_arvados_config "$1"
830     retry do_install_once ${@}
831 }
832
833 do_install_once() {
834     title "install $1"
835     timer_reset
836
837     result=
838     if which deactivate >/dev/null; then deactivate; fi
839     if [[ "$1" != "env" ]] && ! . "$VENV3DIR/bin/activate"; then
840         result=1
841     elif [[ "$2" == "go" ]]
842     then
843         go install -ldflags "$(go_ldflags)" "$WORKSPACE/$1"
844     elif [[ "$2" == "pip" ]]
845     then
846         # $3 can name a path directory for us to use, including trailing
847         # slash; e.g., the bin/ subdirectory of a virtualenv.
848
849         # Need to change to a different directory after creating
850         # the source dist package to avoid a pip bug.
851         # see https://arvados.org/issues/5766 for details.
852
853         # Also need to install twice, because if it believes the package is
854         # already installed, pip it won't install it.  So the first "pip
855         # install" ensures that the dependencies are met, the second "pip
856         # install" ensures that we've actually installed the local package
857         # we just built.
858         cd "$WORKSPACE/$1" \
859             && "${3}python3" setup.py sdist rotate --keep=1 --match .tar.gz \
860             && cd "$WORKSPACE" \
861             && "${3}pip3" install --no-cache-dir "$WORKSPACE/$1/dist"/*.tar.gz \
862             && "${3}pip3" install --no-cache-dir --no-deps --ignore-installed "$WORKSPACE/$1/dist"/*.tar.gz
863     elif [[ "$2" != "" ]]
864     then
865         "install_$2"
866     else
867         "install_$1"
868     fi
869     result=${result:-$?}
870     checkexit $result "$1 install"
871     title "install $1 -- `timer`"
872     return $result
873 }
874
875 bundle_install_trylocal() {
876     (
877         set -e
878         echo "(Running bundle install --local. 'could not find package' messages are OK.)"
879         if ! "$bundle" install --local --no-deployment; then
880             echo "(Running bundle install again, without --local.)"
881             "$bundle" install --no-deployment
882         fi
883         "$bundle" package
884     )
885 }
886
887 install_doc() {
888     cd "$WORKSPACE/doc" \
889         && bundle_install_trylocal \
890         && rm -rf .site
891 }
892
893 install_gem() {
894     gemname=$1
895     srcpath=$2
896     with_test_gemset gem_uninstall_if_exists "$gemname" \
897         && cd "$WORKSPACE/$srcpath" \
898         && bundle_install_trylocal \
899         && gem build "$gemname.gemspec" \
900         && with_test_gemset gem install --no-document $(ls -t "$gemname"-*.gem|head -n1)
901 }
902
903 install_sdk/ruby() {
904     install_gem arvados sdk/ruby
905 }
906
907 install_sdk/R() {
908   if [[ "$NEED_SDK_R" = true ]]; then
909     cd "$WORKSPACE/sdk/R" \
910        && Rscript --vanilla install_deps.R
911   fi
912 }
913
914 install_sdk/perl() {
915     cd "$WORKSPACE/sdk/perl" \
916         && perl Makefile.PL INSTALL_BASE="$PERLINSTALLBASE" \
917         && make install INSTALLDIRS=perl
918 }
919
920 install_sdk/cli() {
921     install_gem arvados-cli sdk/cli
922 }
923
924 install_services/login-sync() {
925     install_gem arvados-login-sync services/login-sync
926 }
927
928 install_services/api() {
929     stop_services
930     check_arvados_config "services/api"
931     cd "$WORKSPACE/services/api" \
932         && RAILS_ENV=test bundle_install_trylocal \
933             || return 1
934
935     rm -f config/environments/test.rb
936     cp config/environments/test.rb.example config/environments/test.rb
937
938     # Clear out any lingering postgresql connections to the test
939     # database, so that we can drop it. This assumes the current user
940     # is a postgresql superuser.
941     cd "$WORKSPACE/services/api" \
942         && test_database=$("${VENV3DIR}/bin/python3" -c "import yaml; print(yaml.safe_load(open('$ARVADOS_CONFIG','r'))['Clusters']['zzzzz']['PostgreSQL']['Connection']['dbname'])") \
943         && psql "$test_database" -c "SELECT pg_terminate_backend (pg_stat_activity.pid::int) FROM pg_stat_activity WHERE pg_stat_activity.datname = '$test_database';" 2>/dev/null
944
945     mkdir -p "$WORKSPACE/services/api/tmp/pids"
946
947     cert="$WORKSPACE/services/api/tmp/self-signed"
948     if [[ ! -e "$cert.pem" || "$(date -r "$cert.pem" +%s)" -lt 1512659226 ]]; then
949         (
950             dir="$WORKSPACE/services/api/tmp"
951             set -e
952             openssl req -newkey rsa:2048 -nodes -subj '/C=US/ST=State/L=City/CN=localhost' -out "$cert.csr" -keyout "$cert.key" </dev/null
953             openssl x509 -req -in "$cert.csr" -signkey "$cert.key" -out "$cert.pem" -days 3650 -extfile <(printf 'subjectAltName=DNS:localhost,DNS:::1,DNS:0.0.0.0,DNS:127.0.0.1,IP:::1,IP:0.0.0.0,IP:127.0.0.1')
954         ) || return 1
955     fi
956
957     cd "$WORKSPACE/services/api" \
958         && rm -rf tmp/git \
959         && mkdir -p tmp/git \
960         && cd tmp/git \
961         && tar xf ../../test/test.git.tar \
962         && mkdir -p internal.git \
963         && git --git-dir internal.git init \
964             || return 1
965
966     (
967         set -ex
968         cd "$WORKSPACE/services/api"
969         export RAILS_ENV=test
970         if bin/rails db:environment:set ; then
971             bin/rake db:drop
972         fi
973         bin/rake db:setup
974         bin/rake db:fixtures:load
975     ) || return 1
976 }
977
978 declare -a pythonstuff
979 pythonstuff=(
980     sdk/python:py3
981     sdk/cwl:py3
982     services/dockercleaner:py3
983     services/fuse:py3
984     tools/crunchstat-summary:py3
985 )
986
987 declare -a gostuff
988 gostuff=($(cd "$WORKSPACE" && git ls-files | grep '\.go$' | sed -e 's/\/[^\/]*$//' | sort -u))
989
990 install_apps/workbench() {
991     cd "$WORKSPACE/apps/workbench" \
992         && mkdir -p tmp/cache \
993         && RAILS_ENV=test bundle_install_trylocal \
994         && RAILS_ENV=test RAILS_GROUPS=assets "$bundle" exec rake npm:install
995 }
996
997 test_doc() {
998     (
999         set -e
1000         cd "$WORKSPACE/doc"
1001         ARVADOS_API_HOST=pirca.arvadosapi.com
1002         # Make sure python-epydoc is installed or the next line won't
1003         # do much good!
1004         PYTHONPATH=$WORKSPACE/sdk/python/ "$bundle" exec rake linkchecker baseurl=file://$WORKSPACE/doc/.site/ arvados_workbench_host=https://workbench.$ARVADOS_API_HOST arvados_api_host=$ARVADOS_API_HOST
1005     )
1006 }
1007
1008 test_gofmt() {
1009     cd "$WORKSPACE" || return 1
1010     dirs=$(ls -d */ | egrep -v 'vendor|tmp')
1011     [[ -z "$(gofmt -e -d $dirs | tee -a /dev/stderr)" ]]
1012 }
1013
1014 test_services/api() {
1015     rm -f "$WORKSPACE/services/api/git-commit.version"
1016     cd "$WORKSPACE/services/api" \
1017         && eval env RAILS_ENV=test ${short:+RAILS_TEST_SHORT=1} "$bundle" exec rake test TESTOPTS=\'-v -d\' ${testargs[services/api]}
1018 }
1019
1020 test_sdk/ruby() {
1021     cd "$WORKSPACE/sdk/ruby" \
1022         && "$bundle" exec rake test TESTOPTS=-v ${testargs[sdk/ruby]}
1023 }
1024
1025 test_sdk/R() {
1026   if [[ "$NEED_SDK_R" = true ]]; then
1027     cd "$WORKSPACE/sdk/R" \
1028         && Rscript --vanilla run_test.R
1029   fi
1030 }
1031
1032 test_sdk/cli() {
1033     cd "$WORKSPACE/sdk/cli" \
1034         && mkdir -p /tmp/keep \
1035         && KEEP_LOCAL_STORE=/tmp/keep "$bundle" exec rake test TESTOPTS=-v ${testargs[sdk/cli]}
1036 }
1037
1038 test_sdk/java-v2() {
1039     cd "$WORKSPACE/sdk/java-v2" && gradle test ${testargs[sdk/java-v2]}
1040 }
1041
1042 test_services/login-sync() {
1043     cd "$WORKSPACE/services/login-sync" \
1044         && "$bundle" exec rake test TESTOPTS=-v ${testargs[services/login-sync]}
1045 }
1046
1047 test_apps/workbench_units() {
1048     local TASK="test:units"
1049     cd "$WORKSPACE/apps/workbench" \
1050         && eval env RAILS_ENV=test ${short:+RAILS_TEST_SHORT=1} "$bundle" exec rake ${TASK} TESTOPTS=\'-v -d\' ${testargs[apps/workbench]} ${testargs[apps/workbench_units]}
1051 }
1052
1053 test_apps/workbench_functionals() {
1054     local TASK="test:functionals"
1055     cd "$WORKSPACE/apps/workbench" \
1056         && eval env RAILS_ENV=test ${short:+RAILS_TEST_SHORT=1} "$bundle" exec rake ${TASK} TESTOPTS=\'-v -d\' ${testargs[apps/workbench]} ${testargs[apps/workbench_functionals]}
1057 }
1058
1059 test_apps/workbench_integration() {
1060     local TASK="test:integration"
1061     cd "$WORKSPACE/apps/workbench" \
1062         && eval env RAILS_ENV=test ${short:+RAILS_TEST_SHORT=1} "$bundle" exec rake ${TASK} TESTOPTS=\'-v -d\' ${testargs[apps/workbench]} ${testargs[apps/workbench_integration]}
1063 }
1064
1065 test_apps/workbench_benchmark() {
1066     local TASK="test:benchmark"
1067     cd "$WORKSPACE/apps/workbench" \
1068         && eval env RAILS_ENV=test ${short:+RAILS_TEST_SHORT=1} "$bundle" exec rake ${TASK} ${testargs[apps/workbench_benchmark]}
1069 }
1070
1071 test_apps/workbench_profile() {
1072     local TASK="test:profile"
1073     cd "$WORKSPACE/apps/workbench" \
1074         && eval env RAILS_ENV=test ${short:+RAILS_TEST_SHORT=1} "$bundle" exec rake ${TASK} ${testargs[apps/workbench_profile]}
1075 }
1076
1077 install_deps() {
1078     # Install parts needed by test suites
1079     do_install env
1080     do_install cmd/arvados-server go
1081     do_install sdk/cli
1082     do_install sdk/perl
1083     do_install sdk/python pip "${VENV3DIR}/bin/"
1084     do_install sdk/ruby
1085     do_install services/api
1086     do_install services/arv-git-httpd go
1087     do_install services/keepproxy go
1088     do_install services/keep-web go
1089 }
1090
1091 install_all() {
1092     do_install env
1093     do_install doc
1094     do_install sdk/ruby
1095     do_install sdk/R
1096     do_install sdk/perl
1097     do_install sdk/cli
1098     do_install services/login-sync
1099     for p in "${pythonstuff[@]}"
1100     do
1101        dir=${p%:py3}
1102        if [[ -z ${skip[python3]} ]]; then
1103            do_install ${dir} pip "$VENV3DIR/bin/"
1104        fi
1105     done
1106     for g in "${gostuff[@]}"
1107     do
1108         do_install "$g" go
1109     done
1110     do_install services/api
1111     do_install apps/workbench
1112 }
1113
1114 test_all() {
1115     stop_services
1116     do_test services/api
1117
1118     # Shortcut for when we're only running apiserver tests. This saves a bit of time,
1119     # because we don't need to start up the api server for subsequent tests.
1120     if [ ! -z "$only" ] && [ "$only" == "services/api" ]; then
1121         rotate_logfile "$WORKSPACE/services/api/log/" "test.log"
1122         exit_cleanly
1123     fi
1124
1125     do_test gofmt
1126     do_test doc
1127     do_test sdk/ruby
1128     do_test sdk/R
1129     do_test sdk/cli
1130     do_test services/login-sync
1131     do_test sdk/java-v2
1132     for p in "${pythonstuff[@]}"
1133     do
1134         dir=${p%:py3}
1135         if [[ -z ${skip[python3]} ]]; then
1136             do_test ${dir} pip "$VENV3DIR/bin/"
1137         fi
1138     done
1139
1140     for g in "${gostuff[@]}"
1141     do
1142         do_test "$g" go
1143     done
1144     do_test apps/workbench_units
1145     do_test apps/workbench_functionals
1146     do_test apps/workbench_integration
1147     do_test apps/workbench_benchmark
1148     do_test apps/workbench_profile
1149 }
1150
1151 test_go() {
1152     do_test gofmt
1153     for g in "${gostuff[@]}"
1154     do
1155         do_test "$g" go
1156     done
1157 }
1158
1159 help_interactive() {
1160     echo "== Interactive commands:"
1161     echo "TARGET                 (short for 'test DIR')"
1162     echo "test TARGET"
1163     echo "10 test TARGET         (run test 10 times)"
1164     echo "test TARGET:py3        (test with python3)"
1165     echo "test TARGET -check.vv  (pass arguments to test)"
1166     echo "install TARGET"
1167     echo "install env            (go/python libs)"
1168     echo "install deps           (go/python libs + arvados components needed for integration tests)"
1169     echo "reset                  (...services used by integration tests)"
1170     echo "exit"
1171     echo "== Test targets:"
1172     echo "${!testfuncargs[@]}" | tr ' ' '\n' | sort | column
1173 }
1174
1175 initialize
1176
1177 declare -A testfuncargs=()
1178 for g in "${gostuff[@]}"; do
1179     testfuncargs[$g]="$g go"
1180 done
1181 for p in "${pythonstuff[@]}"; do
1182     dir=${p%:py3}
1183     testfuncargs[$dir:py3]="$dir pip $VENV3DIR/bin/"
1184 done
1185
1186 testfuncargs["sdk/cli"]="sdk/cli"
1187 testfuncargs["sdk/R"]="sdk/R"
1188 testfuncargs["sdk/java-v2"]="sdk/java-v2"
1189 testfuncargs["apps/workbench_units"]="apps/workbench_units"
1190 testfuncargs["apps/workbench_functionals"]="apps/workbench_functionals"
1191 testfuncargs["apps/workbench_integration"]="apps/workbench_integration"
1192 testfuncargs["apps/workbench_benchmark"]="apps/workbench_benchmark"
1193 testfuncargs["apps/workbench_profile"]="apps/workbench_profile"
1194
1195 if [[ -z ${interactive} ]]; then
1196     install_all
1197     test_all
1198 else
1199     skip=()
1200     only=()
1201     only_install=()
1202     if [[ -e "$VENV3DIR/bin/activate" ]]; then stop_services; fi
1203     setnextcmd() {
1204         if [[ "$TERM" = dumb ]]; then
1205             # assume emacs, or something, is offering a history buffer
1206             # and pre-populating the command will only cause trouble
1207             nextcmd=
1208         elif [[ ! -e "$VENV3DIR/bin/activate" ]]; then
1209             nextcmd="install deps"
1210         else
1211             nextcmd=""
1212         fi
1213     }
1214     echo
1215     help_interactive
1216     nextcmd="install deps"
1217     setnextcmd
1218     HISTFILE="$WORKSPACE/tmp/.history"
1219     history -r
1220     while read -p 'What next? ' -e -i "$nextcmd" nextcmd; do
1221         history -s "$nextcmd"
1222         history -w
1223         count=1
1224         if [[ "${nextcmd}" =~ ^[0-9] ]]; then
1225           read count nextcmd <<<"${nextcmd}"
1226         fi
1227         read verb target opts <<<"${nextcmd}"
1228         target="${target%/}"
1229         target="${target/\/:/:}"
1230         case "${verb}" in
1231             "exit" | "quit")
1232                 exit_cleanly
1233                 ;;
1234             "reset")
1235                 stop_services
1236                 ;;
1237             "test" | "install")
1238                 case "$target" in
1239                     "")
1240                         help_interactive
1241                         ;;
1242                     all | deps)
1243                         ${verb}_${target}
1244                         ;;
1245                     *)
1246                         argstarget=${target%:py3}
1247                         testargs["$argstarget"]="${opts}"
1248                         tt="${testfuncargs[${target}]}"
1249                         tt="${tt:-$target}"
1250                         while [ $count -gt 0 ]; do
1251                           do_$verb $tt
1252                           let "count=count-1"
1253                         done
1254                         ;;
1255                 esac
1256                 ;;
1257             "" | "help" | *)
1258                 help_interactive
1259                 ;;
1260         esac
1261         if [[ ${#successes[@]} -gt 0 || ${#failures[@]} -gt 0 ]]; then
1262             report_outcomes
1263             successes=()
1264             failures=()
1265         fi
1266         cd "$WORKSPACE"
1267         setnextcmd
1268     done
1269     echo
1270 fi
1271 exit_cleanly